/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSB DFUp̊֐錾܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _HOST_DFU_TASK_H_
#define _HOST_DFU_TASK_H_

//_____ ݸٰ ____________________________________________________________

#include "config.h"

//_____ ϸ ________________________________________________________________

#define DFU_DETACH				0x00
#define DFU_DNLOAD				0x01
#define DFU_UPLOAD				0x02
#define DFU_GETSTATUS			0x03
#define DFU_CLRSTATUS			0x04
#define DFU_GETSTATE			0x05
#define DFU_ABORT				0x06

#define RECORD_MARK				':'
#define DATA_RECORD				0x00
#define PAGE_RECORD				0x04

#define ATMEL_VID				VID_ATMEL
#define AT90DFU_PID				PID_AT90USB128_DFU

#define MAX_DATA_PER_RECORD		16

#define Dfu_download(n)			(usb_request.bmRequestType = USB_SETUP_SET_CLASS_INTER,\
								 usb_request.bRequest      = DFU_DNLOAD,\
								 usb_request.wValue        = 0,\
								 usb_request.wIndex        = 0,\
								 usb_request.wLength       = n,\
								 usb_request.uncomplete_read = FALSE,\
								 host_send_control(data_stage))

#define Dfu_upload(n)			(usb_request.bmRequestType = USB_SETUP_GET_CLASS_INTER,\
								 usb_request.bRequest      = DFU_UPLOAD,\
								 usb_request.wValue        = 0,\
								 usb_request.wIndex        = 0,\
								 usb_request.wLength       = n,\
								 usb_request.uncomplete_read = FALSE,\
								 host_send_control(data_stage))

#define Dfu_get_status()		(usb_request.bmRequestType = USB_SETUP_GET_CLASS_INTER,\
								 usb_request.bRequest      = DFU_GETSTATUS,\
								 usb_request.wValue        = 0,\
								 usb_request.wIndex        = 0,\
								 usb_request.wLength       = 6,\
								 usb_request.uncomplete_read = FALSE,\
								 host_send_control(data_stage))

#define Dfu_read_manuf_id()		(data_stage[0]=0x05,\
								 data_stage[1]=0x01,\
								 data_stage[2]=0x30,\
									Dfu_download(3),\
									Dfu_upload(1))

#define Dfu_erase()				(data_stage[0]=0x04,\
								 data_stage[1]=0x00,\
								 data_stage[2]=0xFF,\
									Dfu_download(3))

#define Dfu_set_page(n)			(data_stage[0]=0x06,\
								 data_stage[1]=0x03,\
								 data_stage[2]=0x00,\
								 data_stage[3]=n,\
									Dfu_download(4))

#define Dfu_start_appli(n)		(data_stage[0]=0x04,\
								 data_stage[1]=0x03,\
								 data_stage[2]=0x00,\
									Dfu_download(3),\
									Dfu_get_status())

#define FIRMWARE_NAME			"FIRMWARE.HEX"
#define SIZE_BUF_STR			36

//_____ 錾 _______________________________________________________________

extern U8 dfu_connected;

void dfu_read (U16 start,U16 end,U8 *buf);
void dfu_prog (U16 start,U16 end,U8 *buf);
U8 dfu_load_hex (void);
void dfu_flush_prog (void);
U8 ascii_to_bin (U8 b);

#endif /* _HOST_DFU_TASK_H_ */
