/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBp̂߂mainB
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author               Atmel Corporation: http://www.atmel.com \n
//!                       Support and FAQ: http://support.atmel.no/
//!
//! ***************************************************************************
//!
//! @mainpage AT90USBxxx ϳ+eʋL
//!
//! @section intro 
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//!
//! 쌠ʒmɂĂ \ref lic_page ̧قǂłB
//!
//! @section Revision Revision
//!
//! @par V2.0.3
//!
//! USB Stack
//! - Fix bug during attach (the interrupt must be disable during attach to don't freeze clock)
//! - Class MSC :
//!   - Fix bug in sense command (USB MS device mode)
//!   - Fix bug on Write Protect Management under MAC OS
//!   - Improve MSC compliance
//!   - Add MSC compliance for Linux 2.4 kernel
//!
//! @par V2.0.2
//!
//! USB Stack
//! - improve USB Chap9 and MSC compliance
//!
//! @par V2.0.1
//!
//! USB Stack
//! - Add three possibilities for SN on USB
//! - Move VBus interrupt to VBus pooling
//! - Fix USB constant about Device Status
//!
//! New watchdog driver
//!
//! Update SPI driver
//!
//! Fix & Clean DataFlash driver
//!
//! Fixed Set/Clear prescaler 
//!
//! @par V2.0.0
//! First release
//!
//! @section install 
//! ̑gݍ݉p ނAT90USBxxxłHIDϳƑeʋLu
//! u̎@܂B
//!
//! @section sample pɂ
//! ނSTK526pɔz܂B
//!
//! @section arch \
//! }Ő}悤ɁAp_main.çقɒu܂B
//! main֐͍ŏɌv敔̏sǍɖJԂős܂B
//! v敔conf_scheduler.ḩقŒ`ꂽƑSĂĂԒPȖJԂłB
//! Ԍv͑SsꂸAƂ̍Ō̎Ɍv敔͌`Ԑݒ(conf_scheduler.h)
//! ̧قŒ`ꂽ̍ƂĂт܂B
//!
//! 2dp͈ȉ2̈قȂƂɊÂ܂B
//! - usb_task(usb_task.cg ̧)͑u`ԂłUSBʗ(ڑF)
//! sƂłB
//! - ϳƂϳۂ̕USBνĂւ̕񍐍\zs܂B
//! - storage_task͑eʋL׽߂A ײނǗ܂B
//!
//! \image html arch_full.gif
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */
 

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "modules/scheduler/scheduler.h"
#include "lib_mcu/wdt/wdt_drv.h"
#include "lib_mcu/power/power_drv.h"
#include "lib_mcu/usb/usb_drv.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

int main (void)
{
	Usb_enable_regulator();
	wdtdrv_disable();
	Clear_prescaler();
	scheduler();
	return 0;
}

//! \name nޑx̂߂̎葱
//! ̂̂RAMOCPUۯ𑝂܂B
//! @{
#ifdef __GNUC__
  // RAM(3)Oɒʏ֐uAW۰/۰ނ폜
  char __low_level_init(void) __attribute__ ((section (".init3"),naked));
#endif

#ifdef __cplusplus
extern "C" {
#endif
char __low_level_init()
{
	Clear_prescaler();
	return 1;
}
#ifdef __cplusplus
}
#endif
//! @}
